function Character(){
	this.position = new Point();
	this.size = 0;
	this.life = 0;
	this.param = 0;
}

Character.prototype.init = function(size, life){
	this.size = size;
	this.life = life;
	this.param = 0;
};

function CharacterShot(){
	this.position = new Point();
	this.size = 0;
	this.speed = 0;
	this.alive = false;
}

CharacterShot.prototype.set = function(p, size, speed){
	// WZbg
	 this.position.x = p.x;
	 this.position.y = p.y;
	
	// TCYAXs[hZbg
	 this.size = size;
	 this.speed = speed;
	
	// tO𗧂Ă
	 this.alive = true;
};

CharacterShot.prototype.move = function(){
	// W^speedړ
	 this.position.y -= this.speed * 5;
	
	// ȏ̍WɓBĂ琶tO~낷
	 if(this.position.y < -this.size){
	 	this.alive = false;
	 }
};

function Shield(){
	this.position = new Point();
	this.parent = null;
	this.life = 0;
	this.size = 0;
	this.param = 0;
	this.alive = false;
}

Shield.prototype.set = function(parent, life, size){
	this.parent = parent;
	
	this.life = life;
	this.size = size;
	this.param = 0;
	
	this.alive = true;
};

Shield.prototype.move = function(){
	
	this.position.x = this.parent.position.x;
	this.position.y = this.parent.position.y;
	
};

function CharacterBurst(){
	this.position = new Point();
	this.life = 0;
	this.size = 0;
	this.speed = 0;
	this.param = 0;
	this.alive = false;
}

CharacterBurst.prototype.set = function(p, life, size, speed){
	// WZbg
	 this.position.x = p.x;
	 this.position.y = p.y;
	
	// TCYAXs[hZbg
	 this.life = life;
	 this.size = size;
	 this.speed = speed;
	 this.param = 0;
	
	// tO𗧂Ă
	 this.alive = true;
};

CharacterBurst.prototype.move = function(){
	 this.position.y -= this.speed;
	
	// ȏ̍WɓBĂ琶tO~낷
	 if(this.position.y < -this.size){
	 	this.alive = false;
	 }
};

function Enemy(){
	this.position = new Point();
	this.life = 0;
	this.size = 0;
	this.type = 0;
	this.param = 0;
	this.alive = false;
}

Enemy.prototype.set = function(p, life, size, type){
	// WZbg
	 this.position.x = p.x;
	 this.position.y = p.y;
	
	// TCYA^CvZbg
	 this.life = life;
	 this.size = size;
	 this.type = type;
	
	// p[^Zbg
	 this.param = 0;
	
	// tO𗧂Ă
	 this.alive = true;
};

Enemy.prototype.move = function(){
	// p[^CNg
	 this.param++;
	
	// ^Cvɉĕ
	 switch(this.type){
	 	
	 	case 1:
	 		// XN[̉Eɑ݂E
	 		if(this.position.x > screenCanvas.width / 2){
	 			this.position.y += 2;
	 		}
	 		// 	XN[̍ɑ݂E
	 		if(screenCanvas.width / 2 > this.position.x){
	 			this.position.y -= 4;
	 		}
	 		// XN[̏㑤ɑ݂獶
	 		if(screenCanvas.height / 4 < this.position.y){
	 			this.position.x -= 4;
	 		}
	 		// XN[̉ɑ݂獶
	 		if(this.position.y < screenCanvas.height / 4){
	 			this.position.x += 6;
	 		}
	 		if(this.position.y > screenCanvas.height / 2){
	 			this.position.y -= 5;
	 		}
	 		 break;
	 	case 0:
	 		
	 		// XN[̉Eɑ݂E
	 		if(this.position.x < screenCanvas.width / 2){
	 			this.position.y += 3;
	 		}
	 		// 	XN[̍ɑ݂E
	 		if(screenCanvas.width / 2 < this.position.x){
	 			this.position.y -= 5;
	 		}
	 		// XN[̏㑤ɑ݂獶
	 		if(screenCanvas.height / 4 > this.position.y){
	 			this.position.x -= 4;
	 		}
	 		// XN[̉ɑ݂獶
	 		if(this.position.y > screenCanvas.height / 4){
	 			this.position.x += 2;
	 		}
	 		if(this.position.y > screenCanvas.height / 2){
	 			this.position.y -= 4;
	 		}
	 		break;
	 	case 2:
	 		if((counter % 10) / 5 === 0){
	 			this.position.x = Math.floor( (Math.random() * 385));
	 			this.position.y = Math.floor( (Math.random() * 385));
	 		}
	 		break;
	 }
};

function EnemyShot(){
	this.position = new Point();
	this.vector = new Point();
	this.size = 0;
	this.speed = 0;
	this.alive = false;
}

EnemyShot.prototype.set = function(p, vector, size, speed){
	// WAxNgZbg
	this.position.x = p.x;
	this.position.y = p.y;
	this.vector.x = vector.x;
	this.vector.y = vector.y;
	
	// TCYAXs[hZbg
	this.size = size;
	this.speed = speed;
	
	// tO𗧂Ă
	this.alive = true;
};

EnemyShot.prototype.move = function(){
	// WxNgɉspeedړ
	this.position.x += this.vector.x * this.speed;
	this.position.y += this.vector.y * this.speed;
	
	// ȏ̍WɓBĂ琶tO~낷
	if(
		this.position.x < -this.size ||
		this.position.y < -this.size ||
		this.position.x > this.size + screenCanvas.width ||
		this.position.y > this.size + screenCanvas.height
	){
		this.alive = false;
	}
};